Index: tools/h5repack/h5repack_parse.c
===================================================================
--- tools/h5repack/h5repack_parse.c	(revision 18506)
+++ tools/h5repack/h5repack_parse.c	(working copy)
@@ -19,9 +19,10 @@
 #include <ctype.h>
 
 #include "h5repack.h"
+#include "h5tools.h"
 #include "h5tools_utils.h"
 
-extern char  *progname;
+/*extern char  *progname;*/
 
 /*-------------------------------------------------------------------------
  * Function: parse_filter
@@ -98,7 +99,7 @@
     obj_list = (obj_list_t*) malloc(n*sizeof(obj_list_t));
     if (obj_list==NULL)
     {
-        error_msg(progname, "could not allocate object list\n");
+        error_msg(h5tools_getprogname(), "could not allocate object list\n");
         return NULL;
     }
     *n_objs=n;
@@ -121,7 +122,7 @@
     if (end_obj+1==(int)len)
     {
         if (obj_list) free(obj_list);
-        error_msg(progname, "input Error: Invalid compression type in <%s>\n",str);
+        error_msg(h5tools_getprogname(), "input Error: Invalid compression type in <%s>\n",str);
         exit(EXIT_FAILURE);
     }
 
@@ -159,7 +160,7 @@
                         c = str[u];
                         if (!isdigit(c) && l==-1){
                             if (obj_list) free(obj_list);
-                            error_msg(progname, "compression parameter not digit in <%s>\n",str);
+                            error_msg(h5tools_getprogname(), "compression parameter not digit in <%s>\n",str);
                             exit(EXIT_FAILURE);
                         }
                         if (l==-1)
@@ -179,7 +180,7 @@
                                     filt->cd_values[j++]=H5_SZIP_EC_OPTION_MASK;
                                 else
                                 {
-                                    error_msg(progname, "szip mask must be 'NN' or 'EC' \n");
+                                    error_msg(h5tools_getprogname(), "szip mask must be 'NN' or 'EC' \n");
                                     exit(EXIT_FAILURE);
                                 }
 
@@ -219,7 +220,7 @@
                         c = str[u];
                         if (!isdigit(c) && l==-1){
                             if (obj_list) free(obj_list);
-                            error_msg(progname, "compression parameter is not a digit in <%s>\n",str);
+                            error_msg(h5tools_getprogname(), "compression parameter is not a digit in <%s>\n",str);
                             exit(EXIT_FAILURE);
                         }
                         if (l==-1)
@@ -239,7 +240,7 @@
                                     filt->cd_values[j++]=H5Z_SO_FLOAT_DSCALE;
                                 else
                                 {
-                                    error_msg(progname, "scale type must be 'IN' or 'DS' \n");
+                                    error_msg(h5tools_getprogname(), "scale type must be 'IN' or 'DS' \n");
                                     exit(EXIT_FAILURE);
                                 }
 
@@ -263,7 +264,7 @@
                         c = str[u];
                         if (!isdigit(c)){
                             if (obj_list) free(obj_list);
-                            error_msg(progname, "compression parameter is not a digit in <%s>\n",str);
+                            error_msg(h5tools_getprogname(), "compression parameter is not a digit in <%s>\n",str);
                             exit(EXIT_FAILURE);
                         }
                         stype[m]=c;
@@ -309,7 +310,7 @@
        if (no_param)
        { /*no more parameters, GZIP must have parameter */
            if (obj_list) free(obj_list);
-           error_msg(progname, "missing compression parameter in <%s>\n",str);
+           error_msg(h5tools_getprogname(), "missing compression parameter in <%s>\n",str);
            exit(EXIT_FAILURE);
        }
    }
@@ -325,7 +326,7 @@
        if (no_param)
        { /*no more parameters, SZIP must have parameter */
            if (obj_list) free(obj_list);
-           error_msg(progname, "missing compression parameter in <%s>\n",str);
+           error_msg(h5tools_getprogname(), "missing compression parameter in <%s>\n",str);
            exit(EXIT_FAILURE);
        }
    }
@@ -341,7 +342,7 @@
        if (m>0)
        { /*shuffle does not have parameter */
            if (obj_list) free(obj_list);
-           error_msg(progname, "extra parameter in SHUF <%s>\n",str);
+           error_msg(h5tools_getprogname(), "extra parameter in SHUF <%s>\n",str);
            exit(EXIT_FAILURE);
        }
    }
@@ -356,7 +357,7 @@
        if (m>0)
        { /*shuffle does not have parameter */
            if (obj_list) free(obj_list);
-           error_msg(progname, "extra parameter in FLET <%s>\n",str);
+           error_msg(h5tools_getprogname(), "extra parameter in FLET <%s>\n",str);
            exit(EXIT_FAILURE);
        }
    }
@@ -371,7 +372,7 @@
        if (m>0)
        { /*nbit does not have parameter */
            if (obj_list) free(obj_list);
-           error_msg(progname, "extra parameter in NBIT <%s>\n",str);
+           error_msg(h5tools_getprogname(), "extra parameter in NBIT <%s>\n",str);
            exit(EXIT_FAILURE);
        }
    }
@@ -386,13 +387,13 @@
        if (no_param)
        { /*no more parameters, SOFF must have parameter */
            if (obj_list) free(obj_list);
-           error_msg(progname, "missing compression parameter in <%s>\n",str);
+           error_msg(h5tools_getprogname(), "missing compression parameter in <%s>\n",str);
            exit(EXIT_FAILURE);
        }
    }
    else {
        if (obj_list) free(obj_list);
-       error_msg(progname, "invalid filter type in <%s>\n",str);
+       error_msg(h5tools_getprogname(), "invalid filter type in <%s>\n",str);
        exit(EXIT_FAILURE);
    }
   }
@@ -415,7 +416,7 @@
        if (filt->cd_values[0]>9 )
        {
            if (obj_list) free(obj_list);
-           error_msg(progname, "invalid compression parameter in <%s>\n",str);
+           error_msg(h5tools_getprogname(), "invalid compression parameter in <%s>\n",str);
            exit(EXIT_FAILURE);
        }
        break;
@@ -430,19 +431,19 @@
        if ((pixels_per_block%2)==1)
        {
            if (obj_list) free(obj_list);
-           error_msg(progname, "pixels_per_block is not even in <%s>\n",str);
+           error_msg(h5tools_getprogname(), "pixels_per_block is not even in <%s>\n",str);
            exit(EXIT_FAILURE);
        }
        if (pixels_per_block>H5_SZIP_MAX_PIXELS_PER_BLOCK)
        {
            if (obj_list) free(obj_list);
-           error_msg(progname, "pixels_per_block is too large in <%s>\n",str);
+           error_msg(h5tools_getprogname(), "pixels_per_block is too large in <%s>\n",str);
            exit(EXIT_FAILURE);
        }
        if ( (strcmp(smask,"NN")!=0) && (strcmp(smask,"EC")!=0) )
        {
            if (obj_list) free(obj_list);
-           error_msg(progname, "szip mask must be 'NN' or 'EC' \n");
+           error_msg(h5tools_getprogname(), "szip mask must be 'NN' or 'EC' \n");
            exit(EXIT_FAILURE);
        }
        break;
@@ -519,7 +520,7 @@
     obj_list = (obj_list_t*) malloc(n*sizeof(obj_list_t));
     if (obj_list==NULL)
     {
-        error_msg(progname, "could not allocate object list\n");
+        error_msg(h5tools_getprogname(), "could not allocate object list\n");
         return NULL;
     }
     *n_objs=n;
@@ -543,7 +544,7 @@
     if (end_obj+1==(int)len)
     {
         if (obj_list) free(obj_list);
-        error_msg(progname, "in parse layout, no characters after : in <%s>\n",str);
+        error_msg(h5tools_getprogname(), "in parse layout, no characters after : in <%s>\n",str);
         exit(EXIT_FAILURE);
     }
 
@@ -560,7 +561,7 @@
             else if (strcmp(slayout,"CHUNK")==0)
                 pack->layout=H5D_CHUNKED;
             else {
-                error_msg(progname, "in parse layout, not a valid layout in <%s>\n",str);
+                error_msg(h5tools_getprogname(), "in parse layout, not a valid layout in <%s>\n",str);
                 exit(EXIT_FAILURE);
             }
         }
@@ -584,7 +585,7 @@
         if (j>(int)len)
         {
             if (obj_list) free(obj_list);
-            error_msg(progname, "in parse layout,  <%s> Chunk dimensions missing\n",str);
+            error_msg(h5tools_getprogname(), "in parse layout,  <%s> Chunk dimensions missing\n",str);
             exit(EXIT_FAILURE);
         }
 
@@ -598,7 +599,7 @@
                 && c!='N' && c!='O' && c!='N' && c!='E'
                 ){
                 if (obj_list) free(obj_list);
-                error_msg(progname, "in parse layout, <%s> Not a valid character in <%s>\n",
+                error_msg(h5tools_getprogname(), "in parse layout, <%s> Not a valid character in <%s>\n",
                     sdim,str);
                 exit(EXIT_FAILURE);
             }
@@ -611,7 +612,7 @@
                     pack->chunk.chunk_lengths[c_index]=atoi(sdim);
                     if (pack->chunk.chunk_lengths[c_index]==0) {
                         if (obj_list) free(obj_list);
-                        error_msg(progname, "in parse layout, <%s> conversion to number in <%s>\n",
+                        error_msg(h5tools_getprogname(), "in parse layout, <%s> conversion to number in <%s>\n",
                             sdim,str);
                         exit(EXIT_FAILURE);
                     }
@@ -629,7 +630,7 @@
                         pack->chunk.chunk_lengths[c_index]=atoi(sdim);
                         if (pack->chunk.chunk_lengths[c_index]==0){
                             if (obj_list) free(obj_list);
-                            error_msg(progname, "in parse layout, <%s> conversion to number in <%s>\n",
+                            error_msg(h5tools_getprogname(), "in parse layout, <%s> conversion to number in <%s>\n",
                                 sdim,str);
                             exit(EXIT_FAILURE);
                         }
Index: tools/h5repack/h5repacktst.c
===================================================================
--- tools/h5repack/h5repacktst.c	(revision 18506)
+++ tools/h5repack/h5repacktst.c	(working copy)
@@ -89,10 +89,11 @@
 #define H5REPACK_EXTFILE "h5repack_ext.bin"
 
 
+/*
 const char *progname = "h5repacktst";
 int d_status = EXIT_SUCCESS;
+*/
 
-
 #define DIM1    40
 #define DIM2    20
 #define CDIM1   DIM1/2
@@ -166,6 +167,9 @@
     int szip_can_encode = 0;
 #endif
 
+	h5tools_setprogname("h5repacktst");
+	h5tools_setstatus(EXIT_SUCCESS);
+
     /* initialize */
     memset(&diff_options, 0, sizeof (diff_opt_t));
     memset(&pack_options, 0, sizeof (pack_opt_t));
Index: tools/h5jam/h5jam.c
===================================================================
--- tools/h5jam/h5jam.c	(revision 18506)
+++ tools/h5jam/h5jam.c	(working copy)
@@ -22,6 +22,7 @@
 
 #include "hdf5.h"
 #include "H5private.h"
+#include "h5tools.h"
 #include "h5tools_utils.h"
 
 #define TRUE 1
@@ -32,8 +33,11 @@
 hsize_t copy_some_to_file (int, int, hsize_t, hsize_t, ssize_t);
 void parse_command_line (int, const char *[]);
 
+/*
 const char *progname = "h5jam";
 int d_status = EXIT_SUCCESS;
+*/
+
 int do_clobber = FALSE;
 char *output_file = NULL;
 char *input_file = NULL;
@@ -131,14 +135,14 @@
 	  do_clobber = TRUE;
 	  break;
 	case 'h':
-	  usage (progname);
+	  usage (h5tools_getprogname());
 	  exit (EXIT_SUCCESS);
     case 'V':
-	  print_version (progname);
+	  print_version (h5tools_getprogname());
 	  exit (EXIT_SUCCESS);
 	case '?':
 	default:
-	  usage (progname);
+	  usage (h5tools_getprogname());
 	  exit (EXIT_FAILURE);
 	}
     }
@@ -184,21 +188,23 @@
   H5Eget_auto2(H5E_DEFAULT, &func, &edata);
   H5Eset_auto2(H5E_DEFAULT, NULL, NULL);
 
+  h5tools_setprogname("h5jam");
+  h5tools_setstatus(EXIT_SUCCESS);
   parse_command_line (argc, argv);
 
   if (ub_file == NULL)
     {
       /* no user block */
-      error_msg (progname, "no user block file name\n");
-      usage (progname);
+      error_msg (h5tools_getprogname(), "no user block file name\n");
+      usage (h5tools_getprogname());
       exit (EXIT_FAILURE);
     }
 
   if (input_file == NULL)
     {
       /* no user block */
-      error_msg (progname, "no HDF5 file\n");
-      usage (progname);
+      error_msg (h5tools_getprogname(), "no HDF5 file\n");
+      usage (h5tools_getprogname());
       exit (EXIT_FAILURE);
     }
 
@@ -206,7 +212,7 @@
 
   if (testval <= 0)
     {
-      error_msg (progname, "Input HDF5 file is not HDF \"%s\"\n", input_file);
+      error_msg (h5tools_getprogname(), "Input HDF5 file is not HDF \"%s\"\n", input_file);
       exit (EXIT_FAILURE);
     }
 
@@ -214,14 +220,14 @@
 
   if (ifile < 0)
     {
-      error_msg (progname, "Can't open input HDF5 file \"%s\"\n", input_file);
+      error_msg (h5tools_getprogname(), "Can't open input HDF5 file \"%s\"\n", input_file);
       exit (EXIT_FAILURE);
     }
 
   plist = H5Fget_create_plist (ifile);
   if (plist < 0)
     {
-      error_msg (progname, "Can't get file creation plist for file \"%s\"\n",
+      error_msg (h5tools_getprogname(), "Can't get file creation plist for file \"%s\"\n",
 		 input_file);
       exit (EXIT_FAILURE);
     }
@@ -229,7 +235,7 @@
   status = H5Pget_userblock (plist, &usize);
   if (status < 0)
     {
-      error_msg (progname, "Can't get user block for file \"%s\"\n",
+      error_msg (h5tools_getprogname(), "Can't get user block for file \"%s\"\n",
 		 input_file);
       exit (EXIT_FAILURE);
     }
@@ -241,7 +247,7 @@
 
   if (ufid < 0)
     {
-      error_msg (progname, "unable to open user block file \"%s\"\n",
+      error_msg (h5tools_getprogname(), "unable to open user block file \"%s\"\n",
 		 ub_file);
       exit (EXIT_FAILURE);
     }
@@ -250,7 +256,7 @@
 
   if (res < 0)
     {
-      error_msg (progname, "Can't stat file \"%s\"\n", ub_file);
+      error_msg (h5tools_getprogname(), "Can't stat file \"%s\"\n", ub_file);
       exit (EXIT_FAILURE);
     }
 
@@ -260,7 +266,7 @@
 
   if (h5fid < 0)
     {
-      error_msg (progname, "unable to open HDF5 file for read \"%s\"\n",
+      error_msg (h5tools_getprogname(), "unable to open HDF5 file for read \"%s\"\n",
 		 input_file);
       exit (EXIT_FAILURE);
     }
@@ -269,7 +275,7 @@
 
   if (res < 0)
     {
-      error_msg (progname, "Can't stat file \"%s\"\n", input_file);
+      error_msg (h5tools_getprogname(), "Can't stat file \"%s\"\n", input_file);
       exit (EXIT_FAILURE);
     }
 
@@ -281,7 +287,7 @@
 
       if (ofid < 0)
 	{
-	  error_msg (progname, "unable to open output file \"%s\"\n",
+	  error_msg (h5tools_getprogname(), "unable to open output file \"%s\"\n",
 		     output_file);
 	  exit (EXIT_FAILURE);
 	}
@@ -292,7 +298,7 @@
 
       if (ofid < 0)
 	{
-	  error_msg (progname, "unable to create output file \"%s\"\n",
+	  error_msg (h5tools_getprogname(), "unable to create output file \"%s\"\n",
 		     output_file);
 	  exit (EXIT_FAILURE);
 	}
@@ -346,7 +352,7 @@
   HDclose (h5fid);
   HDclose (ofid);
 
-  return d_status;
+  return h5tools_getstatus();
 }
 
 /*-------------------------------------------------------------------------
@@ -395,7 +401,7 @@
   if (startin > startout)
     {
       /* this case is prohibited */
-      error_msg (progname, "copy_some_to_file: panic: startin > startout?\n");
+      error_msg (h5tools_getprogname(), "copy_some_to_file: panic: startin > startout?\n");
       exit (EXIT_FAILURE);
     }
 
@@ -405,7 +411,7 @@
 
       if (res < 0)
 	{
-	  error_msg (progname, "Can't stat file \n");
+	  error_msg (h5tools_getprogname(), "Can't stat file \n");
 	  exit (EXIT_FAILURE);
 	}
 
Index: tools/h5jam/h5unjam.c
===================================================================
--- tools/h5jam/h5unjam.c	(revision 18506)
+++ tools/h5jam/h5unjam.c	(working copy)
@@ -24,6 +24,7 @@
 
 #include "hdf5.h"
 #include "H5private.h"
+#include "h5tools.h"
 #include "h5tools_utils.h"
 
 #define TRUE 1
@@ -34,8 +35,11 @@
 hsize_t compute_pad( hsize_t );
 herr_t copy_to_file( int , int , ssize_t, ssize_t );
 
+/* moved into tools lib calls (WB)
 const char  *progname = "h5unjam";
 int          d_status = EXIT_SUCCESS;
+*/
+
 int do_delete = FALSE;
 char *output_file = NULL;
 char *input_file = NULL;
@@ -125,14 +129,14 @@
 	  do_delete = TRUE;
 	  break;
     case 'h':
-        usage(progname);
+        usage(h5tools_getprogname() );
         exit(EXIT_SUCCESS);
     case 'V':
-        print_version (progname);
+        print_version (h5tools_getprogname() );
         exit (EXIT_SUCCESS);
     case '?':
     default:
-        usage(progname);
+        usage(h5tools_getprogname() );
         exit(EXIT_FAILURE);
         }
     }
@@ -140,8 +144,8 @@
     /* check for file name to be processed */
 /*
     if (argc <= opt_ind+2) {
-        error_msg(progname, "missing file name\n");
-        usage(progname);
+        error_msg(h5tools_getprogname() , "missing file name\n");
+        usage(h5tools_getprogname() );
         exit(EXIT_FAILURE);
     }
 */
@@ -182,37 +186,39 @@
     H5Eget_auto2(H5E_DEFAULT, &func, &edata);
     H5Eset_auto2(H5E_DEFAULT, NULL, NULL);
 
+    h5tools_setprogname("h5unjam");
+    h5tools_setstatus(EXIT_SUCCESS);
     parse_command_line(argc, argv);
 
     testval = H5Fis_hdf5(input_file);
 
     if (testval <= 0) {
-        error_msg(progname, "Input HDF5 file is not HDF \"%s\"\n", input_file);
+        error_msg(h5tools_getprogname() , "Input HDF5 file is not HDF \"%s\"\n", input_file);
         exit(EXIT_FAILURE);
     }
 
     ifile = H5Fopen(input_file, H5F_ACC_RDONLY , H5P_DEFAULT);
 
     if (ifile < 0) {
-        error_msg(progname, "Can't open input HDF5 file \"%s\"\n", input_file);
+        error_msg(h5tools_getprogname() , "Can't open input HDF5 file \"%s\"\n", input_file);
         exit(EXIT_FAILURE);
     }
 
     plist = H5Fget_create_plist(ifile);
     if (plist < 0) {
-        error_msg(progname, "Can't get file creation plist for file \"%s\"\n", input_file);
+        error_msg(h5tools_getprogname() , "Can't get file creation plist for file \"%s\"\n", input_file);
         exit(EXIT_FAILURE);
     }
 
     status =  H5Pget_userblock(plist, & usize  );
     if (status < 0) {
-        error_msg(progname, "Can't get user block for file \"%s\"\n", input_file);
+        error_msg(h5tools_getprogname() , "Can't get user block for file \"%s\"\n", input_file);
         exit(EXIT_FAILURE);
     }
 
     if (usize == 0) {
 	/* no user block to remove: message? */
-        error_msg(progname, "\"%s\" has no user block: no change to file\n", input_file);
+        error_msg(h5tools_getprogname() , "\"%s\" has no user block: no change to file\n", input_file);
         exit(EXIT_SUCCESS);
 
     }
@@ -220,7 +226,7 @@
     res = stat(input_file, &sbuf);
 
     if (res < 0) {
-        error_msg(progname, "Can't stat file \"%s\"\n", input_file);
+        error_msg(h5tools_getprogname() , "Can't stat file \"%s\"\n", input_file);
         exit(EXIT_FAILURE);
     }
 
@@ -229,12 +235,12 @@
     ifid = HDopen(input_file,O_RDONLY,0);
 
     if (ifid < 0) {
-        error_msg(progname, "unable to open input HDF5 file \"%s\"\n", input_file);
+        error_msg(h5tools_getprogname() , "unable to open input HDF5 file \"%s\"\n", input_file);
         exit(EXIT_FAILURE);
     }
 
     if (do_delete && (ub_file != NULL)) {
-            error_msg(progname, "??\"%s\"\n", ub_file);
+            error_msg(h5tools_getprogname() , "??\"%s\"\n", ub_file);
             exit(EXIT_FAILURE);
     }
 
@@ -245,7 +251,7 @@
         ufid = HDopen(ub_file,O_WRONLY|O_CREAT|O_TRUNC, 0644 );
 
         if (ufid < 0) {
-            error_msg(progname, "unable to open user block file for output\"%s\"\n", ub_file);
+            error_msg(h5tools_getprogname() , "unable to open user block file for output\"%s\"\n", ub_file);
             exit(EXIT_FAILURE);
         }
     }
@@ -254,14 +260,14 @@
         h5fid = HDopen(input_file,O_WRONLY, 0);
 
         if (h5fid < 0) {
-            error_msg(progname, "unable to open output HDF5 file \"%s\"\n", input_file);
+            error_msg(h5tools_getprogname() , "unable to open output HDF5 file \"%s\"\n", input_file);
             exit(EXIT_FAILURE);
         }
     } else {
         h5fid = HDopen(output_file,O_WRONLY|O_CREAT|O_TRUNC, 0644 );
 
         if (h5fid < 0) {
-            error_msg(progname, "unable to open output HDF5 file \"%s\"\n", output_file);
+            error_msg(h5tools_getprogname() , "unable to open output HDF5 file \"%s\"\n", output_file);
             exit(EXIT_FAILURE);
         }
     }
@@ -270,7 +276,7 @@
     /* copy from 0 to 'usize - 1' into ufid */
     if (!do_delete) {
 	if(copy_to_file(ifid, ufid, 0, (ssize_t) usize) < 0) {
-            error_msg(progname, "unable to copy user block to output file \"%s\"\n", ub_file);
+            error_msg(h5tools_getprogname() , "unable to copy user block to output file \"%s\"\n", ub_file);
             exit(EXIT_FAILURE);
         }
     }
@@ -279,7 +285,7 @@
      * starting at end of user block if present
      */
     if(copy_to_file(ifid, h5fid, (ssize_t) usize, (ssize_t)(fsize - (ssize_t)usize)) < 0) {
-        error_msg(progname, "unable to copy hdf5 data to output file \"%s\"\n", output_file);
+        error_msg(h5tools_getprogname() , "unable to copy hdf5 data to output file \"%s\"\n", output_file);
         exit(EXIT_FAILURE);
     }
 
@@ -288,7 +294,7 @@
     HDclose(h5fid);
     HDclose(ifid);
 
-    return d_status;
+    return h5tools_getstatus();
 }
 
 /*
Index: tools/h5diff/h5diffgentest.c
===================================================================
--- tools/h5diff/h5diffgentest.c	(revision 18506)
+++ tools/h5diff/h5diffgentest.c	(working copy)
@@ -1420,7 +1420,6 @@
     /*-----------------------------------------------------------------------
     * External Links
     *------------------------------------------------------------------------*/
-    /*--------------
     /* source file */
     status = H5Lcreate_external(fname2, "/target_group/x_dset", fid1, "ext_link_dset1", H5P_DEFAULT, H5P_DEFAULT);
     if (status < 0)
Index: tools/h5diff/h5diff_common.c
===================================================================
--- tools/h5diff/h5diff_common.c	(revision 18506)
+++ tools/h5diff/h5diff_common.c	(working copy)
@@ -25,7 +25,9 @@
 
 
 /* module-scoped variables */
+/* disabled. WB
 const char  *progname = "h5diff";
+*/
 
 /*
  * Command-line options: The user can specify short or long-named
@@ -69,6 +71,8 @@
 
     int opt;
 
+    h5tools_setprogname("h5diff");
+
     /* process the command-line */
     memset(options, 0, sizeof (diff_opt_t));
 
@@ -90,7 +94,7 @@
             usage();
             h5diff_exit(EXIT_SUCCESS);
         case 'V':
-            print_version(progname);
+            print_version(h5tools_getprogname() );
             h5diff_exit(EXIT_SUCCESS);
         case 'v':
             options->m_verbose = 1;
@@ -174,7 +178,7 @@
     /* check for file names to be processed */
     if (argc <= opt_ind || argv[ opt_ind + 1 ] == NULL)
     {
-        error_msg(progname, "missing file names\n");
+        error_msg(h5tools_getprogname() , "missing file names\n");
         usage();
         h5diff_exit(EXIT_FAILURE);
     }
Index: tools/lib/h5tools_ref.h
===================================================================
--- tools/lib/h5tools_ref.h	(revision 18506)
+++ tools/lib/h5tools_ref.h	(working copy)
@@ -18,6 +18,8 @@
 
 #include "hdf5.h"
 
+#include "hdf5toolsDllApi.h"
+
 #ifdef __cplusplus
 extern "C" {
 #endif
Index: tools/lib/h5tools.h
===================================================================
--- tools/lib/h5tools.h	(revision 18506)
+++ tools/lib/h5tools.h	(working copy)
@@ -23,8 +23,16 @@
 #define H5TOOLS_H__
 
 #include "hdf5.h"
+#include "hdf5toolsDllApi.h"
 #include "h5tools_error.h"
 
+
+extern hdf5tools_API const char*h5tools_getprogname(void);
+extern hdf5tools_API int h5tools_getstatus(void);
+
+extern hdf5tools_API void h5tools_setprogname(const char*progname);
+extern hdf5tools_API void h5tools_setstatus(int d_status);
+
 #define ESCAPE_HTML             1
 #define OPT(X,S)                ((X) ? (X) : (S))
 #define OPTIONAL_LINE_BREAK     "\001"  /* Special strings embedded in the output */
@@ -532,26 +540,26 @@
 #define H5_TOOLS_DATATYPE        "DATATYPE"
 
 /* Definitions of useful routines */
-extern void     h5tools_init(void);
-extern void     h5tools_close(void);
-extern hid_t    h5tools_fopen(const char *fname, unsigned flags, hid_t fapl,
-                    const char *driver, char *drivername, size_t drivername_len);
-extern int      h5tools_dump_dset(FILE *stream, const h5tool_format_t *info, hid_t dset,
-                                  hid_t p_typ, struct subset_t *sset, int indentlevel);
-extern int      h5tools_dump_mem(FILE *stream, const h5tool_format_t *info, hid_t obj_id,
-                                 hid_t type, hid_t space, void *mem, int indentlevel);
-extern hid_t    h5tools_get_native_type(hid_t type);
-extern hid_t    h5tools_get_little_endian_type(hid_t type);
-extern hid_t    h5tools_get_big_endian_type(hid_t type);
+extern hdf5tools_API void     h5tools_init(void);
+extern hdf5tools_API void     h5tools_close(void);
+extern hdf5tools_API hid_t    h5tools_fopen(const char *fname, unsigned flags, hid_t fapl,
+                    			    const char *driver, char *drivername, size_t drivername_len);
+extern hdf5tools_API int      h5tools_dump_dset(FILE *stream, const h5tool_format_t *info, hid_t dset,
+                                  		hid_t p_typ, struct subset_t *sset, int indentlevel);
+extern hdf5tools_API int      h5tools_dump_mem(FILE *stream, const h5tool_format_t *info, hid_t obj_id,
+                                 		hid_t type, hid_t space, void *mem, int indentlevel);
+extern hdf5tools_API hid_t    h5tools_get_native_type(hid_t type);
+extern hdf5tools_API hid_t    h5tools_get_little_endian_type(hid_t type);
+extern hdf5tools_API hid_t    h5tools_get_big_endian_type(hid_t type);
 
 
-extern void     h5tools_dump_simple_data(FILE *stream, const h5tool_format_t *info, hid_t container,
-                         h5tools_context_t *ctx/*in,out*/, unsigned flags,
-                         hsize_t nelmts, hid_t type, void *_mem);
+extern hdf5tools_API void     h5tools_dump_simple_data(FILE *stream, const h5tool_format_t *info, hid_t container,
+                         				h5tools_context_t *ctx/*in,out*/, unsigned flags,
+                         				hsize_t nelmts, hid_t type, void *_mem);
 
-extern int      h5tools_canreadf(const char* name,
-                                 hid_t dcpl_id);
-extern int      h5tools_can_encode(H5Z_filter_t filtn);
+extern hdf5tools_API int      h5tools_canreadf(const char* name,
+                    		               hid_t dcpl_id);
+extern hdf5tools_API int      h5tools_can_encode(H5Z_filter_t filtn);
 
 void            init_acc_pos(h5tools_context_t *ctx, hsize_t *dims);
 /*
Index: tools/lib/h5tools_ref.c
===================================================================
--- tools/lib/h5tools_ref.c	(revision 18506)
+++ tools/lib/h5tools_ref.c	(working copy)
@@ -45,9 +45,30 @@
 static H5SL_t *ref_path_table = NULL;   /* the "table" (implemented with a skip list) */
 static hid_t thefile = (-1);
 
-extern char  *progname;
-extern int   d_status;
+static const char  *my_progname = "(undefined)";
+static int   d_status = 0;
 
+void h5tools_setprogname(const char *Progname)
+{
+	my_progname = Progname;
+}
+
+void h5tools_setstatus(int D_status)
+{
+	d_status = D_status;
+}
+
+const char*h5tools_getprogname()
+{
+	return my_progname;
+}
+
+int h5tools_getstatus()
+{
+	return d_status;
+}
+
+
 static int ref_path_table_put(const char *, haddr_t objno);
 
 /*-------------------------------------------------------------------------
@@ -122,7 +143,7 @@
 
     /* Iterate over objects in this file */
     if(h5trav_visit(thefile, "/", TRUE, TRUE, init_ref_path_cb, NULL, NULL) < 0) {
-        error_msg(progname, "unable to construct reference path table\n");
+	    error_msg(h5tools_getprogname(), "unable to construct reference path table\n");
         d_status = EXIT_FAILURE;
     } /* end if */
 
Index: tools/h5copy/h5copy.c
===================================================================
--- tools/h5copy/h5copy.c	(revision 18506)
+++ tools/h5copy/h5copy.c	(working copy)
@@ -19,9 +19,11 @@
 #include <string.h>
 #include <stdlib.h>
 
-const char *progname="h5copy";
+/*const char *progname="h5copy";
 int   d_status;
+*/
 
+
 /* command-line options: short and long-named parameters */
 static const char *s_opts = "d:f:hi:o:ps:vV";
 static struct long_options l_opts[] = {
@@ -176,7 +178,7 @@
  }
  else
  {
-  error_msg(progname, "Error in input flag\n");
+  error_msg( h5tools_getprogname(), "Error in input flag\n");
   return -1;
  }
 
@@ -214,6 +216,9 @@
  char         str_flag[20];
  int          opt;
 
+ h5tools_setprogname("h5copy");
+ h5tools_setstatus(0);
+
  /* initialize h5tools lib */
  h5tools_init();
 
@@ -264,7 +269,7 @@
    break;
 
   case 'V':
-   print_version(progname);
+   print_version(h5tools_getprogname() );
    leave(EXIT_SUCCESS);
    break;
 
@@ -284,28 +289,28 @@
 
  if (fname_src==NULL)
  {
-  error_msg(progname, "Input file name missing\n");
+  error_msg(h5tools_getprogname(), "Input file name missing\n");
   usage();
   leave(EXIT_FAILURE);
  }
 
  if (fname_dst==NULL)
  {
-  error_msg(progname, "Output file name missing\n");
+  error_msg(h5tools_getprogname(), "Output file name missing\n");
   usage();
   leave(EXIT_FAILURE);
  }
 
  if (oname_src==NULL)
  {
-  error_msg(progname, "Source object name missing\n");
+  error_msg(h5tools_getprogname(), "Source object name missing\n");
   usage();
   leave(EXIT_FAILURE);
  }
 
  if (oname_dst==NULL)
  {
-  error_msg(progname, "Destination object name missing\n");
+  error_msg(h5tools_getprogname(), "Destination object name missing\n");
   usage();
   leave(EXIT_FAILURE);
  }
@@ -322,7 +327,7 @@
  *-------------------------------------------------------------------------*/
  if (fid_src==-1)
  {
-  error_msg(progname, "Could not open input file <%s>...Exiting\n", fname_src);
+  error_msg(h5tools_getprogname(), "Could not open input file <%s>...Exiting\n", fname_src);
   if (fname_src)
    free(fname_src);
   leave(EXIT_FAILURE);
@@ -345,7 +350,7 @@
  *-------------------------------------------------------------------------*/
  if (fid_dst==-1)
  {
-  error_msg(progname, "Could not open output file <%s>...Exiting\n", fname_dst);
+  error_msg(h5tools_getprogname(), "Could not open output file <%s>...Exiting\n", fname_dst);
   if (fname_src)
    free(fname_src);
   if (fname_dst)
@@ -386,7 +391,7 @@
 
     /* Create link creation property list */
     if((lcpl_id = H5Pcreate(H5P_LINK_CREATE)) < 0) {
-        error_msg(progname, "Could not create link creation property list\n");
+        error_msg(h5tools_getprogname(), "Could not create link creation property list\n");
         goto error;
     } /* end if */
 
@@ -394,13 +399,13 @@
     if(parents) {
         /* Set the intermediate group creation property */
         if(H5Pset_create_intermediate_group(lcpl_id, 1) < 0) {
-            error_msg(progname, "Could not set property for creating parent groups\n");
+            error_msg(h5tools_getprogname(), "Could not set property for creating parent groups\n");
             goto error;
         } /* end if */
 
         /* Display some output if requested */
         if(verbose)
-            printf("%s: Creating parent groups\n", progname);
+            printf("%s: Creating parent groups\n", h5tools_getprogname());
     } /* end if */
 
 /*-------------------------------------------------------------------------
